﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.3
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region


Sub Process_Globals
	Public GPS1 As GPS
	Private gpsStarted As Boolean
	Private gpsStarted As Boolean
	
	Public flp As FusedLocationProvider
	Public LocationSource As Object
	Private LocationChangedListener As JavaObject
	Public coordinates,lat2,lon2 As String
	public rp as RuntimePermissions
End Sub

Sub Service_Create
	GPS1.Initialize("GPS")
	flp.Initialize("flp")
	flp.Connect
	Wait For flp_ConnectionSuccess
	Log("FLP connected")
	Dim request As LocationRequest
	request.Initialize
	request.SetPriority(request.Priority.PRIORITY_HIGH_ACCURACY)
	request.SetInterval(2000)
	request.SetFastestInterval(1000)
	flp.RequestLocationUpdates(request)
	Dim jo As JavaObject = flp
	LocationSource = jo.CreateEventFromUI("com.google.android.gms.maps.LocationSource", "LocationSource", Null)
	CallSubDelayed2(Main, "LocationSource_Ready", True)
End Sub

Sub LocationSource_Event (MethodName As String, Args() As Object) As Object
	If MethodName = "activate" Then
		LocationChangedListener = Args(0)
		Dim loc As Location = flp.GetLastKnownLocation
		If loc.IsInitialized Then FLP_LocationChanged(loc)
	Else if MethodName = "deactivate" Then
		LocationChangedListener = Null
	End If
	Return Null
End Sub

Sub FLP_ConnectionFailed(ConnectionResult1 As Int)
	CallSubDelayed2(Main, "LocationSource_Ready", False)
	Log(ConnectionResult1)
End Sub

Sub FLP_LocationChanged(Location1 As Location)
	Dim speed As String
	Log("Location Changed: " & Location1)
	'coordinates = Location1
	lat2 = Location1.Latitude
	lon2 = Location1.Longitude
	speed = Location1.Speed
	coordinates = lat2 & "," & lon2
	CallSubDelayed2(Main, "LocationSource_Chnge", coordinates)
	If LocationChangedListener <> Null And LocationChangedListener.IsInitialized Then
		LocationChangedListener.RunMethod("onLocationChanged", Array(Location1))
	End If
End Sub

Sub Service_Start (StartingIntent As Intent)
	Log("Service Started")
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
	Log("Destroyed")
End Sub


Public Sub StartGps
	Log("Connect")
	flp.Connect
	
	Wait For flp_ConnectionSuccess
	Log("FLP connected")
	Dim request As LocationRequest
	request.Initialize
	request.SetPriority(request.Priority.PRIORITY_HIGH_ACCURACY)
	request.SetInterval(2000)
	request.SetFastestInterval(1000)
	flp.RequestLocationUpdates(request)
	Dim jo As JavaObject = flp
	LocationSource = jo.CreateEventFromUI("com.google.android.gms.maps.LocationSource", "LocationSource", Null)
	CallSubDelayed2(Main, "LocationSource_Ready", True)
End Sub

Public Sub StopGps
	Log("Stop")
	flp.Disconnect
	
End Sub

